"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FetchService = void 0;
const common_1 = require("@nestjs/common");
const fetch_constants_1 = require("./fetch.constants");
let FetchService = class FetchService {
    constructor(defaults = {}) {
        this.defaults = defaults;
    }
    request(request) {
        return fetch(request);
    }
    createRequest(url, options) {
        const _a = Object.assign(Object.assign({}, this.defaults), options), { baseUrl } = _a, init = __rest(_a, ["baseUrl"]);
        return new Request(new URL(url, baseUrl), init);
    }
    get(url, options = {}) {
        const request = this.createRequest(url, Object.assign(Object.assign({}, options), { method: 'GET' }));
        return this.request(request);
    }
    head(url, options = {}) {
        const request = this.createRequest(url, Object.assign(Object.assign({}, options), { method: 'HEAD' }));
        return this.request(request);
    }
    delete(url, options = {}) {
        const request = this.createRequest(url, Object.assign(Object.assign({}, options), { method: 'DELETE' }));
        return this.request(request);
    }
    patch(url, options = {}) {
        const request = this.createRequest(url, Object.assign(Object.assign({}, options), { method: 'PATCH' }));
        return this.request(request);
    }
    put(url, options = {}) {
        const request = this.createRequest(url, Object.assign(Object.assign({}, options), { method: 'PUT' }));
        return this.request(request);
    }
    post(url, options = {}) {
        const request = this.createRequest(url, Object.assign(Object.assign({}, options), { method: 'POST' }));
        return this.request(request);
    }
};
FetchService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)(fetch_constants_1.FETCH_MODULE_OPTIONS)),
    __metadata("design:paramtypes", [Object])
], FetchService);
exports.FetchService = FetchService;
